
# Some ideas for how to do this taken from
# Davide Cervone's forum post fromSunday, 23 August 2015, 09:24 AM
# http://webwork.maa.org/moodle/mod/forum/discuss.php?d=3734&parent=10135

sub ColumnMatrixPartialCredit {
  my $maxIncorrectEntryMessages = shift;
  return sub {
    my $ans = shift; 
    $ans->{_filter_name} = "Column Matrix Partial Credit";
    my $correct = $ans->{correct_value};
    my $student = $ans->{student_value};

    if ($ans->{score} < 1 && defined($correct) &&
          defined($student) && $student->class eq "Matrix") {
      my @ansSize = $correct->dimensions;
      my $ansRows = $ansSize[0];
      my $ansCols = $ansSize[1];

      my $NumCorrect = 0;
      my $NumIncorrect = 0;
      my @messages;
      for( my $ii = 1; $ii <= $ansRows; $ii++ ) {
        for( my $jj = 1; $jj <= $ansCols; $jj++ ) {
          if ( $student->element($ii,$jj) == $correct->element($ii,$jj) ) {
            $NumCorrect++;
          } else {
            $NumIncorrect++;
            push( @messages, "Your answer has an incorrect entry in coordinate $ii.$BR");
          }
        }
      }
      if ( $NumIncorrect > 0 ) {
        my $message = "Your vector has $NumIncorrect incorrect entries.$BR";
        if ( $NumIncorrect == 1 ) {
          $message = "Your vector has just one incorrect entry.$BR";
        }
        my $ii = $maxIncorrectEntryMessages; 
                 # Max number of specific incorrect entries to report
        while ( ( $ii > 0 ) && @messages ) {
          $ii--;
          $message .= shift( @messages );
        }
        if ( @messages ) {
          $message .= "There are additional incorrect entries.$BR";
        }
        $ans->{ans_message} = $message unless $ans->{isPreview};
      }
      # score based on number of correct entries
      $ans->score( $NumCorrect / ( $ansRows * $ansCols ) );
    }
    return $ans;
  }
}

