loadMacros("MathObjects.pl");

################################################

sub basis_checker_one_matrix {

      # we are given a single matrix as student and correct answer.

      my ( $correct, $student, $answerHash ) = @_;

      # Most of the answer checking is done on integers
      # or on decimals like 0.24381729, so we will set the
      # tolerance accordingly in a local context.
      my $context = Context()->copy;
      $context->flags->set(
        tolerance => 0.0000001,
        tolType => "absolute",
      );

      my ($nr, $nc) = $correct->dimensions;
      my @C2 = ();
      my $sizeC2 = $nr * $nc;
      for ( my $ii = 1; $ii <= $nr ; $ii++ ) {
        for ( my $jj = 1; $jj <= $nc ; $jj++ ) {
          push( @C2, $correct->element($ii,$jj) );
        }
      } 

      #warn "nr = $nr, nc = $nc, C = [ " . join(",",@C2)."]";

      ($nr, $nc) = $student->dimensions();
      my $sizeS2 = $nr * $nc;
      my @S2 = ();
      for ( my $ii = 1; $ii <= $nr ; $ii++ ) {
        for ( my $jj = 1; $jj <= $nc ; $jj++ ) {
          push( @S2, $student->element($ii,$jj) );
        }
      }  

      #warn "nr = $nr, nc = $nc, C = [ " . join(",",@S2)."]";

      if ( $sizeC2 != $sizeS2 ) {
        return 0; # Sizes are NOT compatible
      }

      my $C = Vector($context,[@C2]);
      my $S = Vector($context,[@S2]);

      # This test is overly permissive in terms of small shifts being ignored
      my $test1 = $S->isParallel($C);

      if ( ! $test1 ) {
        return 0;
      }

      # If the prior test passed, use a rank based test
      my $M1 = Matrix( [ 
            Matrix($context,[[ @C2 ]])->row(1), 
            Matrix($context,[[ @S2 ]])->row(1),
         ] ) ;
      my $rank1 = rank( $M1 );
      #warn "M1 = $M1, r1 = $rank1";
      if ( $rank1 == 1 ) {
        return 1;
      } else {
        return 0;
      }
}
